## zmat 0.9.8+ds

=== Makefile ===
############################################################
#  ZMat: A portable C-library and MATLAB/Octave toolbox for inline data compression
#
#  Author: Qianqian Fang <q.fang at neu.edu>
############################################################

PKGNAME=zmat
LIBNAME=lib$(PKGNAME)
MEXNAME=zipmat
VERSION=0.9.0
SOURCE=src

all: mex oct lib dll

lib:
	-$(MAKE) -C $(SOURCE) lib
dll:
	-$(MAKE) -C $(SOURCE) dll
mex:
	-$(MAKE) -C $(SOURCE) mex
oct:
	-$(MAKE) -C $(SOURCE) oct
clean:
	-rm -rf $(LIBNAME).* $(MEXNAME).mex*
	-$(MAKE) -C $(SOURCE) clean

.DEFAULT_GOAL := mex

=== src/CMakeLists.txt ===
#################################################################
#  CMake configure file for ZMat
#  Qianqian Fang <q.fang at neu.edu>
#  2020/05/23
#################################################################

cmake_minimum_required(VERSION 3.3)

project(zmat)

find_package(ZLIB REQUIRED)
find_package(Matlab)

option(STATIC_LIB "Build static library" ON)

# C Options
set(CMAKE_C_FLAGS "-g -Wall -O3 -fPIC")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/../)

# Add include directories
include_directories(../include)
include_directories(lz4)
include_directories(easylzma)
include_directories(easylzma/pavlov)

# Add all project units

if(STATIC_LIB)
  add_library(zmat STATIC
    zmatlib.c
    lz4/lz4.c
    lz4/lz4hc.c
    easylzma/compress.c
    easylzma/decompress.c
    easylzma/lzma_header.c
    easylzma/lzip_header.c
    easylzma/common_internal.c
    easylzma/pavlov/LzmaEnc.c
    easylzma/pavlov/LzmaDec.c
    easylzma/pavlov/LzmaLib.c
    easylzma/pavlov/LzFind.c
    easylzma/pavlov/Bra.c
    easylzma/pavlov/BraIA64.c
    easylzma/pavlov/Alloc.c
    easylzma/pavlov/7zCrc.c
    )
else()
# Add all project units
  add_library(zmat SHARED
    zmatlib.c
    lz4/lz4.c
    lz4/lz4hc.c
    easylzma/compress.c
    easylzma/decompress.c
    easylzma/lzma_header.c
    easylzma/lzip_header.c
    easylzma/common_internal.c
    easylzma/pavlov/LzmaEnc.c
    easylzma/pavlov/LzmaDec.c
    easylzma/pavlov/LzmaLib.c
    easylzma/pavlov/LzFind.c
    easylzma/pavlov/Bra.c
    easylzma/pavlov/BraIA64.c
    easylzma/pavlov/Alloc.c
    easylzma/pavlov/7zCrc.c
    )
endif()

# Link options
target_link_libraries(
    zmat
    ZLIB::ZLIB
    )

if(Matlab_FOUND)
    matlab_add_mex(
      NAME zipmat
      SRC zmat.cpp
      LINK_TO mex mx zmat
    )
endif()

=== src/Makefile ===
#################################################################
#  Makefile for ZMAT
#  Qianqian Fang <q.fang at neu.edu>
#  2019/04/30
#################################################################

BACKEND ?=

ROOTDIR ?=..
ZMATDIR ?=$(ROOTDIR)
LIBDIR  ?=$(ROOTDIR)/lib

MKDIR      :=mkdir

MEX=mex
AR=$(CC)
ECHO       := echo

BINARY:=zipmat
OUTPUT_DIR=$(ZMATDIR)

DOXY       := doxygen
DOCDIR     := $(ZMATDIR)/doc
DOXYCFG=zmat.cfg

INCLUDEDIRS=-I../include -Ieasylzma -Ieasylzma/pavlov -Ilz4

CUOMPLINK=

ARCH = $(shell uname -m)
PLATFORM = $(shell uname -s)

DLLFLAG=-fPIC
OMP=-fopenmp

CPPOPT=-g -Wall -O3 -fPIC #-g -Wall -std=c99 # -DUSE_OS_TIMER

OUTPUTFLAG:=-o
OBJSUFFIX=.o
EXESUFFIX=.mex*

FILES=zmatlib lz4/lz4 lz4/lz4hc easylzma/compress easylzma/decompress \
easylzma/lzma_header easylzma/lzip_header easylzma/common_internal \
easylzma/pavlov/LzmaEnc easylzma/pavlov/LzmaDec easylzma/pavlov/LzmaLib \
easylzma/pavlov/LzFind easylzma/pavlov/Bra easylzma/pavlov/BraIA64 \
easylzma/pavlov/Alloc easylzma/pavlov/7zCrc

ifeq ($(findstring CYGWIN,$(PLATFORM)), CYGWIN)
  ifeq ($(findstring x86_64,$(ARCH)), x86_64)
      LINKOPT=-L"$(CUDA_PATH)/lib/x64" $(CUDART)
  else
      LINKOPT=-L"$(CUDA_PATH)/lib/Win32" $(CUDART)
  endif
  INCLUDEDIRS +=-I"$(CUDA_PATH)/lib/include"
  CPPOPT =-c -D_CRT_SECURE_NO_DEPRECATE -DWIN32
  OBJSUFFIX=.obj
  EXESUFFIX=
  DLLFLAG=
  OMP=-fopenmp
  MEX=cmd /c mex
else ifeq ($(findstring Darwin,$(PLATFORM)), Darwin)

else
  CPPOPT+=
  CUCCOPT+=-Xcompiler $(OMP)
  ifeq ($(findstring x86_64,$(ARCH)), x86_64)
     CPPOPT +=
     CUCCOPT +=-m64
     ifeq "$(wildcard /usr/local/cuda/lib64)" "/usr/local/cuda/lib64"
        ifeq ($(BACKEND),cuda)
           LINKOPT=-L/usr/local/cuda/lib64 $(CUDART) -lm -lstdc++
        else ifeq ($(BACKEND),cudastatic)
           LINKOPT=-L/usr/local/cuda/lib64 $(CUDART) -lm -static-libgcc -static-libstdc++
        endif
     endif
  endif
endif

ifeq ($(MAKECMDGOALS),lib)
   AR         :=ar
   ARFLAGS    :=cr
   BINARY     :=libzmat.a
   AROUTPUT   :=
   LINKOPT    :=
   OUTPUT_DIR :=$(LIBDIR)
   ifeq ($(findstring Darwin,$(PLATFORM)), Darwin)
      OUTPUTFLAG :=
   endif
endif

ifeq ($(MAKECMDGOALS),dll)
   OUTPUTFLAG :=-o
   BINARY     :=libzmat.so
   OUTPUT_DIR :=$(LIBDIR)

   ifeq ($(findstring Darwin,$(PLATFORM)), Darwin)
      ARFLAGS    :=-shared -Wl,-install_name,$(BINARY).1 -lz
   else
      ARFLAGS    :=-shared -Wl,-soname,$(BINARY).1 -lz
   endif
endif

ifeq ($(MAKECMDGOALS),dll)
   BINARY     :=libzmat.so
endif

dll:   CPPOPT     +=$(DLLFLAG)
dll:   AR         :=gcc
dll:   ARFLAGS    ?=-shared -Wl,-soname,$(BINARY).1
dll:   LINKOPT    :=
dll:   AROUTPUT   :=-o

oct mex: CPPOPT+= $(DLLFLAG)
oct:   OUTPUT_DIR=..
oct:   AR= CXXFLAGS='-O3' LFLAGS='$(-lz)' LDFLAGS='$(LFLAGS)' mkoctfile zmat.cpp
oct:   BINARY=zmat.mex
oct:   ARFLAGS    :=
oct:   LINKOPT+=--mex $(INCLUDEDIRS)
oct:   CXX=mkoctfile

mex:   CXX=$(MEX)
mex:   OUTPUTFLAG:=-output
mex:   AR=$(MEX) zmat.cpp $(INCLUDEDIRS)
mex:   LINKOPT+= -cxx CXXLIBS='$$CXXLIBS -lz -static-libgcc -static-libstdc++' -outdir $(ZMATDIR)
mex:   ARFLAGS    :=
mex:   OUTPUT_DIR=..

all: mex

TARGETSUFFIX:=$(suffix $(BINARY))

doc: makedocdir
	$(DOXY) $(DOXYCFG)

OBJS      := $(addsuffix $(OBJSUFFIX), $(FILES))

all dll lib mex oct: $(OUTPUT_DIR)/$(BINARY)

makedirs:
	@if test ! -d $(OUTPUT_DIR); then $(MKDIR) $(OUTPUT_DIR); fi

makedocdir:
	@if test ! -d $(DOCDIR); then $(MKDIR) $(DOCDIR); fi

$(OUTPUT_DIR)/$(BINARY): makedirs $(OBJS)
$(OUTPUT_DIR)/$(BINARY): $(OBJS)
	@$(ECHO) Building $@
	$(AR) $(ARFLAGS) $(OUTPUTFLAG) $@ $(OBJS) $(LINKOPT) $(USERLINKOPT)

%$(OBJSUFFIX): %.cpp
	$(CXX) $(INCLUDEDIRS) $(CPPOPT) -c -o $@ $<

%$(OBJSUFFIX): %.c
	@$(ECHO) Building $@
	$(CC) $(INCLUDEDIRS) $(CPPOPT) -c -o $@ $<

%$(OBJSUFFIX): %.cu
	@$(ECHO) Building $@
	$(CUDACC) -c $(CUCCOPT) -o $@  $<

clean:
	-rm -f $(OBJS) $(OUTPUT_DIR)/$(BINARY)$(EXESUFFIX) zmat$(OBJSUFFIX) $(LIBDIR)/*

.PHONY: all mex oct lib dll

.DEFAULT_GOAL := all

=== test/c/Makefile ===
all:
	$(CC) -g -Wall -pedantic testzmat.c -o testzmat -DNO_LZMA -DNO_LZ4 -I../../src -L../../lib -lzmat -lz
clean:
	-rm -f testzmat

=== test/f90/Makefile ===
F90 :=gfortran

all:
	$(F90) -g -Wall -pedantic -c ../../fortran90/zmatlib.f90
	$(F90) -g -Wall -pedantic testzmat.f90 -o testzmat -L../../lib -lzmat -lz
clean:
	-rm -f testzmat *.o *.mod

=== debian/changelog ===
zmat (0.9.8+ds-3) unstable; urgency=medium

  * Team upload
  * Fix libzmat.so symlink (Closes: #985515)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 29 Mar 2021 17:58:31 +0200

zmat (0.9.8+ds-2) unstable; urgency=medium

  * Team upload

  * d/watch: Bump version to 4

 -- Rafael Laboissière <rafael@debian.org>  Fri, 13 Nov 2020 15:32:24 -0300

zmat (0.9.8+ds-1) unstable; urgency=medium

  * Initial release (Closes: #962603)

 -- Qianqian Fang <fangqq@gmail.com>  Mon, 21 Sep 2020 11:54:20 -0300

=== debian/control ===
Source: zmat
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Qianqian Fang <fangqq@gmail.com>
Section: libs
Priority: optional
Standards-Version: 4.5.0
Build-Depends: debhelper-compat (= 13), liblz4-dev, zlib1g-dev, dh-octave
Homepage: https://github.com/fangq/zmat
Vcs-Git: https://salsa.debian.org/pkg-octave-team/zmat.git
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/zmat
Rules-Requires-Root: no

Package: libzmat1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libzmat1
Description: compression library - runtime
 ZMat is a portable C library to enable easy-to-use data compression
 and decompression (such as zlib/gzip/lzma/lzip/lz4/lz4hc algorithms)
 and base64 encoding/decoding in an application.
 It is fast and compact, can process a large array within a fraction
 of a second. Among the supported compression methods, lz4 is the
 fastest for compression/decompression; lzma is the slowest but has
 the highest compression ratio; zlib/gzip have the best balance
 between speed and compression time.

Package: libzmat1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libzmat1 (= ${binary:Version}), ${misc:Depends}
Provides: libzmat1-dev
Description: compression library - development
 The libzmat1-dev package provides the headers files and tools you may need to
 develop applications using libzmat1.

Package: octave-zmat
Section: science
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${octave:Depends}, ${misc:Depends}
Description: in-memory data compression for Octave
 ZMat is a portable mex function to enable zlib/gzip/lzma/lzip/lz4/lz4hc
 based data compression/decompression and base64 encoding/decoding support
 in MATLAB and GNU Octave. It is fast and compact, can process a large
 array within a fraction of a second. Among the 6 supported compression
 methods, lz4 is the fastest for compression/decompression; lzma is the
 slowest but has the highest compression ratio; zlib/gzip have the best
 balance between speed and compression time.

Package: matlab-zmat
Section: contrib/science
Architecture: all
Depends: libzmat1-dev (>= ${source:Version}), matlab-support, ${misc:Depends}
Description: in-memory data compression for MATLAB
 ZMat is a portable mex function to enable zlib/gzip/lzma/lzip/lz4/lz4hc
 based data compression/decompression and base64 encoding/decoding support
 in MATLAB and GNU Octave.
 .
 This package builds MATLAB bindings for zmat at installation
 time. Note that this package depends on MATLAB -- a commercial
 software that needs to be obtain and installed separately.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE =1

OCTDIR=$(shell octave-config --print LOCALOCTFILEDIR)

%:
	+dh $@

execute_before_dh_auto_clean:
	$(MAKE) -C src clean
	$(RM) -rf src/makefile test/c/makefile test/f90/makefile

override_dh_auto_configure:
	cp src/Makefile src/makefile
	cp test/c/Makefile test/c/makefile
	cp test/f90/Makefile test/f90/makefile
	sed -i -e 's/lz4\/lz4 lz4\/lz4hc//g' src/makefile
	sed -i -e 's/-lz$$/-lz -llz4/g' test/c/makefile test/f90/makefile

override_dh_auto_build:
	$(MAKE) -C src lib
	$(MAKE) -C src oct USERLINKOPT="-lz -llz4"
	$(MAKE) -C src dll USERLINKOPT="-lz -llz4"

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.txt

override_dh_auto_install:
	install -d debian/libzmat1-dev/usr/include;
	install include/zmatlib.h debian/libzmat1-dev/usr/include;
	install fortran90/zmatlib.f90 debian/libzmat1-dev/usr/include;

	set -e; arch=$$(dpkg-architecture -qDEB_HOST_MULTIARCH); \
	install -d debian/libzmat1/usr/lib/$$arch; \
	install -d debian/libzmat1-dev/usr/lib/$$arch; \
	mv lib/libzmat.so debian/libzmat1/usr/lib/$$arch/libzmat.so.1; \
	mv lib/libzmat.a debian/libzmat1/usr/lib/$$arch/libzmat.a; \
	ln -sf libzmat.so.1 debian/libzmat1-dev/usr/lib/$$arch/libzmat.so
	
	chmod -x zipmat.mex
	dh_install -poctave-zmat zipmat.mex $(OCTDIR)/zmat
	dh_install -poctave-zmat zmat.m $(OCTDIR)/zmat
	dh_octave_substvar -poctave-zmat

=== debian/watch ===
version=4

opts="compression=gz, oversionmangle=s/(.*)/$1+ds/, dversionmangle=s/\+ds(\.\d+)?$//, \
    filenamemangle=s/\S+\/v?(\S+)\.tar\.gz/zmat-$1\.tar\.gz/" \
    https://github.com/fangq/zmat/tags .*/v?(\d\S+)\.tar\.gz \
    debian debian/repack

## zmat 0.9.9%2Bds.1

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,22 @@
 Uploaders: Qianqian Fang <fangqq@gmail.com>
 Section: libs
 Priority: optional
-Standards-Version: 4.5.0
-Build-Depends: debhelper-compat (= 13), liblz4-dev, zlib1g-dev, dh-octave
-Homepage: https://github.com/fangq/zmat
+Standards-Version: 4.7.2
+Build-Depends: debhelper-compat (= 13),
+               dh-octave,
+               libzstd-dev,
+               liblz4-dev,
+               libblosc2-dev
+Homepage: https://github.com/NeuroJSON/zmat
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/zmat.git
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/zmat
-Rules-Requires-Root: no
 
 Package: libzmat1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Provides: libzmat1
-Description: compression library - runtime
+Description: compression library - shared library object
  ZMat is a portable C library to enable easy-to-use data compression
  and decompression (such as zlib/gzip/lzma/lzip/lz4/lz4hc algorithms)
  and base64 encoding/decoding in an application.
@@ -25,15 +28,20 @@
  the highest compression ratio; zlib/gzip have the best balance
  between speed and compression time.
 
-Package: libzmat1-dev
+Package: libzmat-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends: libzmat1 (= ${binary:Version}), ${misc:Depends}
-Provides: libzmat1-dev
-Description: compression library - development
- The libzmat1-dev package provides the headers files and tools you may need to
- develop applications using libzmat1.
+Provides: libzmat-dev
+Breaks: libzmat1 (<< 0.9.9+ds.1-4)
+Replaces: libzmat1 (<< 0.9.9+ds.1-4)
+Description: compression library - development files
+ ZMat is a portable C library to enable easy-to-use data compression
+ and decompression (such as zlib/gzip/lzma/lzip/lz4/lz4hc algorithms)
+ and base64 encoding/decoding in an application.
+ .
+ This package provides the development files.
 
 Package: octave-zmat
 Section: science
@@ -52,7 +60,7 @@
 Package: matlab-zmat
 Section: contrib/science
 Architecture: all
-Depends: libzmat1-dev (>= ${source:Version}), matlab-support, ${misc:Depends}
+Depends: libzmat-dev (>= ${source:Version}), matlab-support, ${misc:Depends}
 Description: in-memory data compression for MATLAB
  ZMat is a portable mex function to enable zlib/gzip/lzma/lzip/lz4/lz4hc
  based data compression/decompression and base64 encoding/decoding support
